| AI Engine-ML v2 Intrinsics User Guide (v2026.1)

Loading...
Searching...
No Matches
Shift element
Vector Operations

These intrinsics allow inserting of an element into a vector by pushing in a new value at one end of the vector. More...

## Right-most insertion (left shift)
  Push new element value on right-most lane (shifting register to the left) Parameters
  v | The vector containing to be shifted
  s | value to shift in.
v64int8 | shiftl_elem (v64int8 v, int s)
v32int16 | shiftl_elem (v32int16 v, int s)
v16int32 | shiftl_elem (v16int32 v, int s)
v64uint8 | shiftl_elem (v64uint8 v, unsigned int s)
v32uint16 | shiftl_elem (v32uint16 v, unsigned int s)
v16uint32 | shiftl_elem (v16uint32 v, unsigned int s)
v16cint16 | shiftl_elem (v16cint16 v, cint16 s)
v16cbfloat16 | shiftl_elem (v16cbfloat16 v, cbfloat16 s)
v16cbfloat16 | shiftl_elem (v16cbfloat16 v, v1cbfloat16 s)
v8cint32 | shiftl_elem (v8cint32 v, cint32_w64 s)
v8cint32 | shiftl_elem (v8cint32 v, cint32 s)
v8cfloat | shiftl_elem (v8cfloat v, cfloat_w64 s)
v8cfloat | shiftl_elem (v8cfloat v, cfloat s)
v32bfloat16 | shiftl_elem (v32bfloat16 v, bfloat16 s)
v32float16 | shiftl_elem (v32float16 v, float16 s)
v64float8 | shiftl_elem (v64float8 v, float8 s)
v64bfloat8 | shiftl_elem (v64bfloat8 v, bfloat8 s)
v16accfloat | shiftl_elem (v16accfloat v, float s)
v16float | shiftl_elem (v16float v, float s)

## Left-most insertion (right shift)
  Push new element value on left-most lane (shifting register to the right) Parameters
  v | The vector containing to be shifted
  s | value to shift in.
v64int8 | shiftr_elem (v64int8 v, int s)
v32int16 | shiftr_elem (v32int16 v, int s)
v16int32 | shiftr_elem (v16int32 v, int s)
v64uint8 | shiftr_elem (v64uint8 v, unsigned int s)
v32uint16 | shiftr_elem (v32uint16 v, unsigned int s)
v16uint32 | shiftr_elem (v16uint32 v, unsigned int s)
v16cint16 | shiftr_elem (v16cint16 v, cint16 s)
v16cbfloat16 | shiftr_elem (v16cbfloat16 v, cbfloat16 s)
v16cbfloat16 | shiftr_elem (v16cbfloat16 v, v1cbfloat16 s)
v8cint32 | shiftr_elem (v8cint32 v, cint32_w64 s)
v8cint32 | shiftr_elem (v8cint32 v, cint32 s)
v8cfloat | shiftr_elem (v8cfloat v, cfloat_w64 s)
v8cfloat | shiftr_elem (v8cfloat v, cfloat s)
v32bfloat16 | shiftr_elem (v32bfloat16 v, bfloat16 s)
v32float16 | shiftr_elem (v32float16 v, float16 s)
v64float8 | shiftr_elem (v64float8 v, float8 s)
v64bfloat8 | shiftr_elem (v64bfloat8 v, bfloat8 s)
v16accfloat | shiftr_elem (v16accfloat v, float s)
v16float | shiftr_elem (v16float v, float s)

## Detailed Description

These intrinsics allow inserting of an element into a vector by pushing in a new value at one end of the vector.

## Function Documentation

## ◆ shiftl_elem() [1/19]

v16accfloat shiftl_elem | ( | v16accfloat | v,
|  | float | s )

## ◆ shiftl_elem() [2/19]

v16cbfloat16 shiftl_elem | ( | v16cbfloat16 | v,
|  | cbfloat16 | s )

## ◆ shiftl_elem() [3/19]

v16cbfloat16 shiftl_elem | ( | v16cbfloat16 | v,
|  | v1cbfloat16 | s )

## ◆ shiftl_elem() [4/19]

v16cint16 shiftl_elem | ( | v16cint16 | v,
|  | cint16 | s )

## ◆ shiftl_elem() [5/19]

v16float shiftl_elem | ( | v16float | v,
|  | float | s )

## ◆ shiftl_elem() [6/19]

v16int32 shiftl_elem | ( | v16int32 | v,
|  | int | s )

## ◆ shiftl_elem() [7/19]

v16uint32 shiftl_elem | ( | v16uint32 | v,
|  | unsigned int | s )

## ◆ shiftl_elem() [8/19]

v32bfloat16 shiftl_elem | ( | v32bfloat16 | v,
|  | bfloat16 | s )

## ◆ shiftl_elem() [9/19]

v32float16 shiftl_elem | ( | v32float16 | v,
|  | float16 | s )

## ◆ shiftl_elem() [10/19]

v32int16 shiftl_elem | ( | v32int16 | v,
|  | int | s )

## ◆ shiftl_elem() [11/19]

v32uint16 shiftl_elem | ( | v32uint16 | v,
|  | unsigned int | s )

## ◆ shiftl_elem() [12/19]

v64bfloat8 shiftl_elem | ( | v64bfloat8 | v,
|  | bfloat8 | s )

## ◆ shiftl_elem() [13/19]

v64float8 shiftl_elem | ( | v64float8 | v,
|  | float8 | s )

## ◆ shiftl_elem() [14/19]

v64int8 shiftl_elem | ( | v64int8 | v,
|  | int | s )

## ◆ shiftl_elem() [15/19]

v64uint8 shiftl_elem | ( | v64uint8 | v,
|  | unsigned int | s )

## ◆ shiftl_elem() [16/19]

v8cfloat shiftl_elem | ( | v8cfloat | v,
|  | cfloat | s )

## ◆ shiftl_elem() [17/19]

v8cfloat shiftl_elem | ( | v8cfloat | v,
|  | cfloat_w64 | s )

## ◆ shiftl_elem() [18/19]

v8cint32 shiftl_elem | ( | v8cint32 | v,
|  | cint32 | s )

## ◆ shiftl_elem() [19/19]

v8cint32 shiftl_elem | ( | v8cint32 | v,
|  | cint32_w64 | s )

## ◆ shiftr_elem() [1/19]

v16accfloat shiftr_elem | ( | v16accfloat | v,
|  | float | s )

## ◆ shiftr_elem() [2/19]

v16cbfloat16 shiftr_elem | ( | v16cbfloat16 | v,
|  | cbfloat16 | s )

## ◆ shiftr_elem() [3/19]

v16cbfloat16 shiftr_elem | ( | v16cbfloat16 | v,
|  | v1cbfloat16 | s )

## ◆ shiftr_elem() [4/19]

v16cint16 shiftr_elem | ( | v16cint16 | v,
|  | cint16 | s )

## ◆ shiftr_elem() [5/19]

v16float shiftr_elem | ( | v16float | v,
|  | float | s )

## ◆ shiftr_elem() [6/19]

v16int32 shiftr_elem | ( | v16int32 | v,
|  | int | s )

## ◆ shiftr_elem() [7/19]

v16uint32 shiftr_elem | ( | v16uint32 | v,
|  | unsigned int | s )

## ◆ shiftr_elem() [8/19]

v32bfloat16 shiftr_elem | ( | v32bfloat16 | v,
|  | bfloat16 | s )

## ◆ shiftr_elem() [9/19]

v32float16 shiftr_elem | ( | v32float16 | v,
|  | float16 | s )

## ◆ shiftr_elem() [10/19]

v32int16 shiftr_elem | ( | v32int16 | v,
|  | int | s )

## ◆ shiftr_elem() [11/19]

v32uint16 shiftr_elem | ( | v32uint16 | v,
|  | unsigned int | s )

## ◆ shiftr_elem() [12/19]

v64bfloat8 shiftr_elem | ( | v64bfloat8 | v,
|  | bfloat8 | s )

## ◆ shiftr_elem() [13/19]

v64float8 shiftr_elem | ( | v64float8 | v,
|  | float8 | s )

## ◆ shiftr_elem() [14/19]

v64int8 shiftr_elem | ( | v64int8 | v,
|  | int | s )

## ◆ shiftr_elem() [15/19]

v64uint8 shiftr_elem | ( | v64uint8 | v,
|  | unsigned int | s )

## ◆ shiftr_elem() [16/19]

v8cfloat shiftr_elem | ( | v8cfloat | v,
|  | cfloat | s )

## ◆ shiftr_elem() [17/19]

v8cfloat shiftr_elem | ( | v8cfloat | v,
|  | cfloat_w64 | s )

## ◆ shiftr_elem() [18/19]

v8cint32 shiftr_elem | ( | v8cint32 | v,
|  | cint32 | s )

## ◆ shiftr_elem() [19/19]

v8cint32 shiftr_elem | ( | v8cint32 | v,
|  | cint32_w64 | s )